<?php

require_once("./lib/BasicFunction.php");
require_once("./Category.class.php");

class Page{
	var $title;
	var $link;
	var $categories;
	var $engine;
	var $hash;
	var $timeout = 25; /** seconds **/
	
	function Page($t, $l, $cs){
		$this->title = $t;
		$this->link = $l;
		$this->categories = $cs;
		$this->hash = md5($l);
	}
	
	function getImagePath( &$category ){
		return ($category->getPath(true)."/{$this->hash}.{$category->img['ext']}");
	}
	
	function setEngine( $e ){
		$this->engine = $e;
	}
	
	/*
	複数カテゴリを持っていて、
	カテゴリごとの画像表示設定が違う場合に表示した時にガタガタになる為
	同じファイルで保存しておくのは不都合。
	同じ URL のページでも違うものが出来上がる可能性がある為、別々に出力する必要がある
	*/
	function toList( $type ){
		$html = "";
		foreach($this->categories as $category){
			switch( $type ){
				case "2":
					$html .= ("{$this->link},".$this->getImagePath($category)."\n" );
					break;
				case "Fake":
					$html .= ("{$this->link}\t".$this->getImagePath($category)."\t{$this->timeout}\t{$category->capture['width']}x{$category->capture['height']}\t{$category->picture['width']}x{$category->picture['height']}\n");
					break;
				case "K":
					$engine = empty($this->engine) ? $category->engine : $this->engine;
					$html .= ("{$this->link}\t".$this->getImagePath($category)."\t{$engine}\t{$this->timeout}\t{$category->capture['width']}x{$category->capture['height']}\t{$category->picture['width']}x{$category->picture['height']}\n");
					break;
				default:
					die("Page object to HTML-List failed. Webnail type is '{$type}'... (It isn't K, 2 or Fake)");
			}
		}
		return $html;
	}
	
	function toHTML( $category, $isXHTML = true ){
		return ("<a href='".htmlspecialcharsEx($this->link)."' title='".htmlspecialcharsEx($this->title)."'><img src='".$this->getImagePath($category)."' alt='".htmlspecialcharsEx($this->title)."' width='".$category->picture['width']."' height='".$category->picture['height']."'".($isXHTML ? " />" : ">")."</a>");
	}
}

?>
