<?php

/*
このファイルが行う事は下記の 3 つ。

XML 設定ファイルの読み込みとまぁまぁの検証
Webnail 用ファイルの作成
設定ファイル読み込み結果のキャッシュの作成

このファイルはなるべくアップロードしないで下さい。
もしアップしても、アップロードしたままにしないで下さい。
セキュリティ的に問題があります。
*/

error_reporting(E_ALL);
mb_internal_encoding("UTF-8");

require_once("./lib/BasicFunction.php");
require_once("./lib/File.php");
require_once("./lib/AbstractXMLProcesser.php");
require_once("./lib/SerializedFile.php");
require_once("./Category.class.php");
require_once("./Page.class.php");

class ThumblinkPrepare{
	var $pages;
	var $categories;
	var $webnail;
	var $option;
	var $config;
	var $_internalDefault = array(
		"c" => "Basic",
		"en" => "IE",
		"img" => array(
			"dir" => "img",
			"ext" => "jpg",
		),
		"cap" => array(
			"width" => "1024",
			"height" => "768",
		),
		"pic" => array(
			"width" => "320",
			"height" => "240",
		),
		"opt" => array(
			"template" => "template.xhtml",
			"limit" => "32",
		),
	);
	var $_defaultCategory; // getDefaultCategory でだけ使用するキャッシュ用の変数です
	
	function main(){
		header("Content-Type: text/plain; charset=utf-8");
		ob_start(); // ※最後まで end しないので処理終了と同時に flash 。
		println("\n読み込みプロセス開始。");
		$this->read();
		println("読み込みが正常に終了しました。\n");
		println("書き込みプロセス開始。");
		$this->write();
		println("書き込みが正常に終了しました。\n");
		println("すべてのプロセスは正常に終了しました。");
		println("もしこのファイル(".basename($_SERVER['PHP_SELF']).")が実際にリンク集を運用するサーバー上にあるのなら削除してください。");
	}
	
	function write(){
		$output = "./sites.lst";
		if( array_key_exists( "out", $_GET) ){
			$output = $_GET['out'];
		}
		println("出力先ファイル: '{$output}' を使用します。");
		if( $output == "./sites.lst" ){
			println(basename($_SERVER['PHP_SELF'])."?out=bar.lst とする事で書き込むリストファイルを変更できます。");
			println("設定ファイルとともに指定する場合は ".basename($_SERVER['PHP_SELF'])."?conf=foo.xml&out=bar.lst とします。");
		}
		$file = new File( $output, "w" );
		println("'{$output}' を正常に開きました。");
		println("ページ情報を書き込みます。");
		foreach($this->pages as $key => $p){
			$file->write( $p->toList( $this->webnail ) );
		}
		$file->close();
		println( "ページ情報の書き込みが終了しました。 (".count($this->pages)." ページ)" );
		
		println("オブジェクトファイル 'option' を作成します。");
		$file = new SerializedFile( "./option" );
		$file->write( $this->option );
		// close 不要
		println("オブジェクトファイル 'option' は正常に書き込みが終了しました。");
		
		println("オブジェクトファイル 'pages' を作成します。");
		$file = new SerializedFile( "./pages" );
		$file->write( $this->pages );
		println("オブジェクトファイル 'pages' は正常に書き込みが終了しました。");
		
		println("オブジェクトファイル 'categories' を作成します。");
		$file = new SerializedFile( "./categories" );
		$file->write( $this->categories );
		println("オブジェクトファイル 'categories' は正常に書き込みが終了しました。");
		
		println("画像を保存するためのディレクトリを生成します。");
		$this->mkdirs();
		println("画像を保存するためのディレクトリを正常に生成しました。");
	}
	
	/**
	* 凄く適当な実装のカテゴリ用ディレクトリ作成関数。
	* パーミッションなんて一切調べてない。
	**/
	function mkdirs(){
		$categories = $this->getAllCategories();
		foreach($categories as $c){
			$path = explode( "/", $c->getPath(true) );
			$piece = "";
			foreach($path as $dir){
				if( filetype($piece.$dir) !== "dir" ){
					@mkdir( $piece.$dir );
				}
				$piece .= $dir."/";
			}
		}
	}
	
	function read(){
		clearstatcache();
		$config = "./sites.xml";
		// 設定ファイル名を引数から求める
		if( array_key_exists( "conf", $_GET) ){
			$config = $_GET['conf'];
		}
		println("設定ファイル: '{$config}' を使用します。");
		if( $config == "./sites.xml" ){
			println(basename($_SERVER['PHP_SELF'])."?conf=foo.xml とする事で読み込む設定ファイルを変更できます。");
		}
		$xml = @domxml_open_mem( file_get_contents($config) ) or die("設定ファイルを正常に読み込めませんでした。おそらく XML が不正なのでしょう。ブラウザで XML ファイルを開いてエラー箇所を確認してください。処理は強制終了しました。");
		println("XML は正常に認識されました。\n");
		
		// root はここでタグ名を調べる事にだけしか使っていません。
		$root = $xml->document_element();
		if( $root->tagname() != "thumblink" ){
			die("ルート要素は <thumblink> でなければなりません。これは Thumblink の設定ファイルではないのかもしれません。処理は強制終了しました。");
		}
		$generator = $xml->get_elements_by_tagname("webnail");
		if( count($generator) == 0 ){
			die("<webnail> が定義されていませんでした。処理は強制終了しました。");
		}
		$generator = $generator[0]->get_content();
		if( ereg("^(K|Fake|2)$", $generator) == false ){
			die("<webnail> は K か Fake か 2 でなければいけません。処理は強制終了しました。");
		}
		$this->webnail = $generator;
				
		println("デフォルト設定を読み込みます。");
		$this->config = $this->_readDefault( $xml );
		println("エンジン名: ".$this->config["en"]);
		println("カテゴリ名: ".$this->config["c"]);
		println("画像撮影幅: ".$this->config["cap"]["width"]);
		println("画像撮影高さ: ".$this->config["cap"]["height"]);
		println("画像表示幅: ".$this->config["pic"]["width"]);
		println("画像表示高さ: ".$this->config["pic"]["height"]);
		println("画像形式: ".$this->config["img"]["ext"]);
		println("画像ディレクトリ: ".$this->config["img"]["dir"]);
		println("デフォルト設定を正常に読み込みました。\n");
		
		println("オプション設定を読み込みます。");
		$this->option = $this->_readOption( $xml->document_element() );
		println("テンプレートファイル名: ".$this->option["template"]);
		println("1ページ最大サムネイル数: ".$this->option["limit"]);
		println("オプション設定を正常に読み込みましした。\n");
		
		println("カテゴリ設定を読み込みます。");
		$this->categories = $this->_readCategory( $xml->document_element() );
		
		if( $this->_defaultCategoryValidate( $this->categories ) == false ){
			die("デフォルトカテゴリ名が子を持たない(末端である)カテゴリに存在しませんでした。処理は強制終了されました。");
		}
		$this->_categoryPathValidate();
		
		println("カテゴリ設定を正常に読み込みました。\n");
		
		println("ページ設定を読み込みます。");
		$this->pages = $this->_readPage( $xml->document_element() );
		$this->_pageValidate();
		println("ページ設定を正常に読み込みました。\n");
	}
	
	function _readOption( &$parentElement ){
		$opt = $parentElement->get_elements_by_tagname("option");
		if( empty($opt) ){
			return $this->_internalDefault["opt"];
		}
		$opt = $opt[0];
		$template = $opt->get_elements_by_tagname("template");
		if( empty($template) ){
			$template = $_internalDefault["opt"]["template"];
		} else {
			$template = $template[0]->get_content();
			$template = mb_convert_kana( $template, "asKV", "UTF-8" );
			if( ereg("^[a-zA-Z0-9\.#\$%&(){}_\^~\+-@]+$", $template ) == false ){
				die($parentElement->tagname()." でのテンプレートファイル名が汎用的ではありませんでした。日本語ファイル名を使っていてもこのエラーが出ます。処理は強制終了されました。");
			}
		}
		$limit = $opt->get_elements_by_tagname("limit");
		if( empty($limit) ){
			$limit = $_internalDefault["opt"]["limit"];
		} else {
			$limit = $limit[0]->get_content();
			$limit = mb_convert_kana( $limit, "asKV", "UTF-8" );
			if( ereg("^[1-9][0-9]*", $limit ) == false ){
				die( $parentElement->tagname()." で定義されている <limit> は空白か、数字以外が混ざっています。処理は強制終了されました。");
			}
		}
		return array(
			"limit" => $limit,
			"template" => $template,
		);
	}
	
	function _readDefault( &$xml ){
		// デフォルト設定の読み込み
		$conf = $xml->get_elements_by_tagname("default");
		if( empty($conf) ){
			// すべて内部デフォルト設定で補う
			return $this->_internalDefault;
		}
		$conf = $conf[0];
		$c = $conf->get_elements_by_tagname("category");
		if( empty($c) ){
			// 内部デフォルトカテゴリ名を設定する。
			$c = $this->_internalDefault["c"];
		} else {
			$c = $c[0]->get_content();
		}
		$en = $conf->get_elements_by_tagname("engine");
		if( empty($en) ){
			// 何も指定がなければとりあえずデフォルトは IE エンジン
			$en = $this->_internalDefault["en"];
		} else {
			$en = $en[0]->get_content();
			if( ereg( "^(IE|Gecko)$", $en) == false ){
				die("<engine> に指定されている文字列 ({$en}) は不正です。IE か Gecko を指定してください。処理は強制終了されました。");
			}
		}
		$def = array(
			"en" => $en,
			"c" => $c,
		);
		$def["cap"] = $this->_readCapture( $conf, $this->_internalDefault["cap"]["width"], $this->_internalDefault["cap"]["height"] );
		$def["pic"] = $this->_readPicture( $conf, $this->_internalDefault["pic"]["width"], $this->_internalDefault["pic"]["height"] );
		$def["img"] = $this->_readImg( $conf, $this->_internalDefault["img"]["dir"], $this->_internalDefault["img"]["ext"]);
		return $def;
	}
	
	function _readCapture( &$parentElement, $width, $height ){
		$cap = AbstractXMLProcesser::getChildElementsByTagName("capture", $parentElement);
		if( empty($cap) ){
			// 設定なし
			return array(
				"width" => $width,
				"height" => $height,
			);
		} else {
			// 設定あり
			return $this->_readBox( $cap[0] );
		}
	}
	
	function _readPicture( &$parentElement, $width, $height ){
		$pic = AbstractXMLProcesser::getChildElementsByTagName("picture", $parentElement);
		if( empty($pic) ){
			// 設定なし
			return array(
				"width" => $width,
				"height" => $height,
			);
		} else {
			// 設定あり
			return $this->_readBox( $pic[0] );
		}
	}
	
	function _readImg( &$parentElement, $dir, $ext ){
		$img = AbstractXMLProcesser::getChildElementsByTagName("image", $parentElement);
		if( empty($img) == false ){
			$img = $img[0];
			$d = $img->get_elements_by_tagname("dir");
			if( empty($d) == false ){
				$dir = $d[0]->get_content();
				$dir = mb_convert_kana( $dir, "asKV", "UTF-8");
				if( ereg( "^[a-zA-Z0-9\+-_]+$", $dir) == false ){
					die("ディレクトリ名は英数字だけで指定しなければいけません。処理は強制終了されました。.");
				}
			}
			$e = $img->get_elements_by_tagname("ext");
			if( empty($e) == false ){
				$ext = strtolower( $e[0]->get_content() );
				if( ereg( "^(jpg|png|gif)$", $ext) == false ){
					die("画像形式は JPG か PNG、あるいは GIF でなければいけません。処理は強制終了されました。");
				}
				if( $this->webnail === "2" and $ext != "jpg" ){
					println("Webnail 2 を指定しているにも関わらず JPG 以外が画像形式に設定されています。強制的に JPG を使用します。");
					$ext = "jpg";
				}
			}
		}
		return array(
			"dir" => $dir,
			"ext" => $ext,
		);
	}
	
	/**
	* parentElement 直下にある width と height を読み込んで連想配列で返す。
	**/
	function _readBox( &$parentElement ){
		$width = $parentElement->get_elements_by_tagname("width");
		if( empty($width) ){
			die("<width> が <".$parentElement->tagname()."> 内に定義されていませんでした。処理は強制終了されました。");
		}
		$width = $width[0]->get_content();
		$width = mb_convert_kana($width, "asKV", "UTF-8");
		if( ereg( "^([1-9][0-9]*|0)$", $width) == false ){
			die( "<".$parentElement->tagname()."> で定義されている <width> は空白か、数字以外が混ざっています。処理は強制終了されました。");
		}
		$height = $parentElement->get_elements_by_tagname("height");
		if( empty($height) ){
			die("<height> が <".$parentElement->tagname()."> 内に定義されていませんでした。処理は強制終了されました。");
		}
		$height = $height[0]->get_content();
		$height = mb_convert_kana($height, "asKV", "UTF-8");
		if( ereg( "^([1-9][0-9]*|0)$", $height) == false ){
			die( $parentElement->tagname()." で定義されている <height> は空白か、数字以外が混ざっています。処理は強制終了されました。");
		}
		return array(
			"width" => $width,
			"height" => $height,
		);
	}
	
	function _readCategory( &$parentElement, $parentCategory = null ){
		$categories = AbstractXMLProcesser::getChildElementsByTagName("category", $parentElement );
		$cList = array();
		foreach($categories as $category){
			$name = AbstractXMLProcesser::getChildElementsByTagName( "name", $category );
			if( empty($name) ){
				die("<name> が <category> 内に定義されていませんでした。処理は強制終了されました。");
			}
			$name = $name[0]->get_content();
			
			$dir = AbstractXMLProcesser::getChildElementsByTagName( "dir", $category );
			if( empty($dir) ){
				die("<dir> がカテゴリ '{$name}' に定義されていませんでした。処理は強制終了されました。");
			}
			$dir = $dir[0]->get_content();
			$dir = mb_convert_kana( $dir, "asKV", "UTF-8");
			if( ereg( "^[a-zA-Z0-9\+-_]+$", $dir) == false ){
					die("カテゴリ '{$name}' の <dir> は不正です。ディレクトリ名は英数字だけで指定しなければいけません。処理は強制終了されました。.");
			}
			
			// レンダリングエンジンを見つける
			$en = AbstractXMLProcesser::getChildElementsByTagName( "engine", $category );
			if( empty($en) ){
				if( $parentCategory !== null ){
					$en = $parentCategory->engine;
				} else {
					$en = $this->config["en"];
				}
			} else {
				$en = $en[0]->get_content();
				if( ereg("^(IE|Gecko)$",$en) == false ){
					die("カテゴリ '{$name}' の <engine> に指定されている文字列 ({$en}) は不正です。IE か Gecko を指定してください。");
				}
			}
			
			// 画像の設定読み込み
			if( $parentCategory === null ){
				// 親がないので自分→デフォルトで優先
				$cap = $this->_readCapture( $category, $this->config["cap"]["width"], $this->config["cap"]["height"] );
				$pic = $this->_readPicture( $category, $this->config["pic"]["width"], $this->config["pic"]["height"] );
				$img = $this->_readImg( $category, $this->config["img"]["dir"], $this->config["img"]["ext"] );
			} else {
				// 親がいるので自分→親で優先
				$cap = $this->_readCapture( $category, $parentCategory->capture["width"], $parentCategory->capture["height"] );
				$pic = $this->_readPicture( $category, $parentCategory->picture["width"], $parentCategory->picture["height"] );
				
				// img > dir に限っては最上位のみ有効。ディレクトリ構造が直感的でなくなるため。
				$owner = $parentCategory->getOwnerCategory();
				$img = $this->_readImg( $category, "dummy", $parentCategory->img["ext"] );
				$img["dir"] = $owner->img["dir"];
			}
			
			$internalCategories = AbstractXMLProcesser::getChildElementsByTagName("category", $category);
			$isDefault = false;
			if( empty($internalCategories) and $this->config["c"] === $name){
				$isDefault = true; // 末端だけがデフォルトカテゴリになれる
			}
			$newCategory = new Category($name, $dir, $en, $img, $cap, $pic, $isDefault );
			if( $parentCategory !== null ){
				$newCategory->setParent( $parentCategory );
			}
			if( empty($internalCategories) == false ){
				$icList = $this->_readCategory( $category, $newCategory );
				foreach($icList as $ic){ // ic は 'Internal Category' の略
					$newCategory->addChild( $ic );
				}
			}
			array_push( $cList, $newCategory );
		}
		if( $parentCategory !== null ){
			if( empty($cList) ){
				// 内部デフォルト設定のカテゴリを登録する。
				// ディレクトリ名以外は <default> に依存。
				array_push( $cList, new Category( $this->config["c"], "default", $this->config["en"], $this->config["img"], $this->config["cap"], $this->config["pic"], true ) );
			} else {
				if( $this->config["c"] === $this->_internalDefault["c"] ){
					println("デフォルトのカテゴリ名が内部デフォルトのカテゴリ名 ({$this->_internalDefault['c']}) と同じですが、カテゴリが定義されています。設定ミスかもしれません。");
				}
			}
		}
		return $cList;
	}
	
	function _defaultCategoryValidate( $categories = null ){
		if( $categories === null ){
			$categories = &$this->categories;
		}
		foreach($categories as $c){
			$children = $c->getChildren();
			if( empty( $children ) ){
				if( $c->isDefault == true ){
					return true;
				}
			} else {
				if( $this->_defaultCategoryValidate( $children ) == true ){
					return true;
				}
			}
		}
		// デフォルトカテゴリがどこかの末端カテゴリに存在しなかった
		// （どこにも存在しなかったという判定ではない点に注意）
		return false;
	}
	
	/**
	* @return array Category 全カテゴリ。
	*
	* 全てのカテゴリを検出して、一重配列の状態で返す。
	**/
	function getAllCategories( $parentCategories = null ){
		if( $parentCategories === null ){
			$parentCategories = & $this->categories;
		}
		$lst = array();
		foreach($parentCategories as $category){
			array_push( $lst, $category );
			$children = $category->getChildren();
			$innerCategories = $this->getAllCategories( $children );
			foreach($innerCategories as $c){
				array_push( $lst, $c );
			}
		}
		return $lst;
	}
	
	function _categoryPathValidate(){
		$categories = $this->getAllCategories();
		$lst = array();
		foreach( $categories as $category ){
			$path = $category->getPath(true);
			$idx = array_search($path,$lst);
			if( $idx == false ){
				array_push( $lst, $path);
			} else {
				println("警告: カテゴリ '".$category->name."' で使用するディレクトリ (".$path.") は、それより前に定義されているカテゴリのどれかと同じです。");
				println("\tあるページがこの 2 つのカテゴリを両方とも持っていて、画像の拡張子も同じである場合、画像ファイルが上書きされます。");
				println("\t2 つのカテゴリで異なる画像撮影設定か画像表示設定をしている場合は、きっと設定ミスです。注意してください。");
			}
		}
	}
	
	function _getDefaultCategory( $categories = null ){
		if( empty($this->_defaultCategory) ){
			if( $categories === null ){
				$categories = & $this->categories;
			}
			foreach( $categories as $c ){
				$children = $c->getChildren();
				if( empty($children) ){
					if( $c->isDefault ){
						$this->_defaultCategory = $c;
						return $c;
					}
				} else {
					$temp = $this->_getDefaultCategory( $children );
					if( is_object($temp) ){
						$this->_defaultCategory = $c;
						return $temp;
					}
				}
			}
			return null;
		} else {
			return $this->_defaultCategory;
		}
	}
	
	/**
	* @access private
	* @return array カテゴリオブジェクトの配列
	* 
	* name と名前が一致するカテゴリを配列で返します。子を持つか否かは関係ありません。
	* 第2引数は内部的に使用するもので、通常は無指定で使います。
	**/
	function _getCategoriesByName( $name, $parentCategories = null ){
		$lst = array();
		if( $parentCategories === null ){
			$parentCategories = & $this->categories;
		}
		foreach($parentCategories as $category){
			if( $category->name === $name ){
				array_push( $lst, $category );
			}
			$children = $category->getChildren();
			if( empty($children) == false ){
				$cCategories = $this->_getCategoriesByName( $name, $children );
				foreach($cCategories as $c){
					array_push( $lst, $c );
				}
			}
		}
		return $lst;
	}
	
	function _readPage( &$root ){
		$pages = AbstractXMLProcesser::getChildElementsByTagName("page", $root );
		$pList = array();
		foreach($pages as $p){
			$title = $p->get_elements_by_tagname("title");
			if( empty($title) ){
				die("<title> が <page> で定義されていませんでした。処理は強制終了されました。");
			}
			$title = $title[0]->get_content();
			if( empty($title) ){
				die("<title> が <page> で空でした。処理は強制終了されました。");
			}
			
			$link = $p->get_elements_by_tagname("link");
			if( empty($link) ){
				die("<link> が <page> で定義されていませんでした(タイトルは '{$title}' でした)。処理は強制終了されました。");
			}
			$link = $link[0]->get_content();
			if( empty($link) ){
				die("<link> が <page> で空でした(タイトルは '{$title}' でした)。処理は強制終了されました。");
			}
			
			// カテゴリの検出と妥当性の検査
			$categories = $p->get_elements_by_tagname("category");
			$cList = array();
			if( empty($categories) ){
				// 無指定ならデフォルトカテゴリを使用
				array_push( $cList, $this->_getDefaultCategory() );
			} else {
				// 指定があれば、それぞれの文字列と一致する、末端のカテゴリを登録する
				foreach( $categories as $category ){
					$cName = $category->get_content();
					$cats = $this->_getCategoriesByName( $cName );
					if( empty($cats) ){
						die("<title> が '{$title}' である <page> の指定カテゴリ名 ({$cName}) は定義されたカテゴリ内にありませんでした。処理は強制終了されました。");
					}
					$valid = false;
					foreach( $cats as $cat ){
						$children = $cat->getChildren();
						if( empty($children) and $cat->name === $cName ){
							$valid = true;
							array_push( $cList, $cat );
						}
					}
					if( $valid == false ){
						die("<title> が '{$title}' である <page> の指定カテゴリ名 ({$cName}) は末端のカテゴリ名ではありませんでした。処理は強制終了されました。");
					}
				}
			}
			
			$page = new Page( $title, $link, $cList );
			// エンジンの検出と妥当性の検査
			$en = $p->get_elements_by_tagname("engine");
			if( empty($en) == false ){
				$en = $en[0]->get_content();
				if( ereg( "^(IE|Gecko)$", $en) == false ){
					die("<title> '{$title}' を持つ <page> 内で <engine> に指定されている文字列 ({$en}) は不正です。IE か Gecko を指定してください。処理は強制終了されました。");
				}
				$page->setEngine( $en );
			}
			array_push( $pList, $page );
		}
		return $pList;
	}
	
	function _pageValidate(){
		$categorizedPage = array();
		foreach($this->pages as $p){
			foreach($p->categories as $c){
				if( array_key_exists( bin2hex($c->getPath()), $categorizedPage ) ){
					array_push($categorizedPage[ bin2hex($c->getPath()) ], $p);
				} else {
					$categorizedPage[ bin2hex($c->getPath()) ] = array($p);
				}
			}
		}
		
		$categories = $this->getAllCategories();
		foreach($categories as $category){
			$children = $category->getChildren();
			if( empty($children) and array_key_exists( bin2hex($category->getPath()), $categorizedPage ) == false ){
				println("警告: カテゴリ '".$category->name."' は使われていません。");
			}
		}
	}
}

$prepare = new ThumblinkPrepare();
$prepare->main();

?>
