<?php

class AbstractXMLProcesser{
	/*
	@access : public static
	@param searchElementName : string : 検索する要素名
	@param targetElement : object : 子ノードを検索する要素ノード
	@return : array : 要素が見つかれば、その要素のノードの集合。無ければ空配列
	@description : targetElement の子ノードに searchElement があればそれらを返却します。孫ノード以降は調べません
	*/
	function getChildElementsByTagName( $searchElementName, & $targetElement ){
		$childs = $targetElement->child_nodes();
		$nodes = array();
		foreach($childs as $child){
			if( $child->node_type() === XML_ELEMENT_NODE and $child->tagname() == $searchElementName ){
				array_push($nodes, $child);
			}
		}
		return $nodes;
	}
	
	/*
	@access : public static
	@param searchElementName : string : 探す要素名
	@param havingTagElement : object : 子ノードを探す要素
	@return : 要素が見つかれば最初に見つかった要素、無ければ作成し追加した要素
	*/
	function getORCreateChildElementByTagName( $searchElementName, & $havingTagElement ){
		$temp = $this->getChildElementsByTagName( $searchElementName, $havingTagElement );
		if( empty($temp) ){
			$root = $havingTagElement->owner_document();
			$element = $root->create_element( $searchElementName );
			$havingTagElement->append_child( $element );
			return $element;
		} else {
			return $temp[0];
		}
	}
	
	/*
	@access : public static
	@param node : object : 設定するノード
	@param tagName : string : ノードを設定される要素名
	@param havingTagElement : object : tagName を持つべき要素オブジェクト
	@return : void
	*/
	function setNode( & $node, $tagName, & $havingTagElement ){
		$old = $this->getORCreateChildElementByTagName($tagName, $havingTagElement);
		$havingTagElement->replace_child($node, $old);
	}
}

?>
