<?php

require_once(dirname(__FILE__)."/Const.php");

/* 全バッファ削除 */
function allBufferClear(){
	if( function_exists("ob_get_level") == true ){
		while( ob_get_level() ){
			ob_end_clean();
		}
	}
}

/* マルチバイト文字を含んでいるかどうかを返す */
function hasMultibyte( $str ){
	return (mb_strlen($str) != strlen($str));
}

/* HTML特殊文字変換 */
function htmlspecialcharsEx( & $text ){
	$translations = array(
		"'" => "&#39;",
	);
	return strtr( htmlspecialchars($text), $translations );
}

/* HTML特殊文字逆変換 */
function html_entity_decode_Ex( & $text ){
	$translations = array(
		"&#39;" => "'",
	);
	return strtr( html_entity_decode($text), $translations );
}

/* 複数行の文を連続改行で分けて段落化 */
function p( & $text, $newline = LF ){
	return ( "<p>".str_replace( "<br />{$newline}<br />{$newline}" , "{$newline}</p><p>{$newline}" , nl2br( $text ) )."</p>" );
}

/* 改行コードを変換 */
function convertNewLine( & $text, $newline = LF ){
	return ereg_replace( "\n|\r|\r\n", $newline, $text );
}

/* 改行付き出力 */
function println( $msg = "", $newline = LF ){
	print( "{$msg}{$newline}" );
}

/* ファイルやディレクトリを削除します。 */
/* http://jp2.php.net/manual/ja/function.rmdir.php のファイル対応版 */
function rm( $obj ){
	if( is_dir($obj) ){ // is_dir()は拡張子の有無しか見ていないらしいがまぁ問題無いから無視。
		$handle = opendir( $obj );
		while( ($dirobj = readdir($handle) ) !== false ){
			if($dirobj != "." and $dirobj != ".."){
				rm( "{$obj}/{$dirobj}" );
			}
		}
		closedir( $handle );
		return @rmdir( $obj );
	} else {
		return @unlink( $obj );
	}
}

/* ディレクトリ中に存在するオブジェクトの取得 */
/* http://jp2.php.net/manual/ja/function.copy.php の抽出オプション付加版 */
function ls_a( $dir = "./" , $filePattern = ".*" ){
	$list = array();

	if($handle = opendir($dir) ){
		while ( ($file = readdir($handle) ) !== false ) {
			if ($file != "." and $file != ".." and mb_ereg_match( $filePattern , $file ) ) {
				array_push($list, $file);
			}
		}
	}
	closedir($handle);
	return $list;
}

/*
配列の値の重複チェック。重複があれば true , なければ false を返す。
比較する対象がクラスオブジェクトである場合でも有効で in_array() より強力。
引数が普通の in_array() と比べて逆である点に注意。
*/
function in_arrayEx( &$ary, &$obj ){
	foreach( $ary as $val ){
		if($val == $obj){
			return true;
		}
	}
	return false;
}

/* ファイル読み込み。file_get_contents() の拡張 */
function getRemoteFile( $file, $timeout = 10 ){
	while( ($s = @file_get_contents($file)) === false ){
		if(--$timeout <= 0) return NG; // PHP5でOOPならここで例外を投げる
		sleep(1);
	}
	return $s;
}

function hasString($str,$search){
	return (mb_strpos($str,$search) === false);
}

?>
